# KDD 2022 Hands-on Tutorial - PECOS: Prediction for Enormous and Correlated Output Spaces

In this tutorial, we will introduce several key functions and features of the PECOS library.
By way of real-world examples, the attendees will learn how to efficiently train large-scale machine learning models for enormous output spaces, and obtain predictions in less than 1 millisecond for a data input with million labels, in the context of product recommendation and natural language processing.
We will also show the flexibility of dealing with diverse machine learning problems and data formats with assorted built-in utilities in PECOS.
By the end of the tutorial, we believe that attendees will be easily capable of adopting certain concepts to their own projects and address different machine learning problems with enormous output spaces.

* Presenters: Hsiang-Fu Yu (Amazon Search), Jiong Zhang (Amazon Search), Wei-Cheng Chang (Amazon Search), Jyun-Yu Jiang (Amazon Search), and Cho-Jui Hsieh (UCLA)

* Contributer: Wei Li (Amazon Search)

## Agenda

| Time | Session | Material |
|---|---|---|
| 8:00 AM - 8:30 AM | Check-in and Environment Setup | |
| 8:30 AM - 8:50 AM | Session 1: Introduction to PECOS | |
| 8:50 AM - 9:30 AM  | Session 2: Extreme Multi-label Ranking with PECOS | [Notebook](https://github.com/amzn/pecos/blob/mainline/tutorials/kdd22/Session%202%20Extreme%20Multi-label%20Ranking%20with%20PECOS.ipynb) |
| 9:30 AM - 10:00 AM | Coffee Break | | 
| 10:00 AM - 10:30 AM | Session 3: Approximate Nearest Neighbor (ANN) Search in PECOS | [Notebook](https://github.com/amzn/pecos/blob/mainline/tutorials/kdd22/Session%203%20Approximate%20Nearest%20Neighbor%20Search%20in%20PECOS.ipynb) |
| 10:30 AM - 11:10 AM | Session 4: Utilities in PECOS | [Notebook](https://github.com/amzn/pecos/blob/mainline/tutorials/kdd22/Session%204%20Utilities%20in%20PECOS.ipynb) |
| 11:10 AM - 11:40 AM | Session 5: XR-Transformer cookbook and Distributed PECOS | [Notebook](https://github.com/amzn/pecos/blob/mainline/tutorials/kdd22/Session%205%20XR-Transformer%20cookbook%20and%20Distributed%20PECOS.ipynb) |
| 11:40 AM - 11:50 AM | Session 6: Research with PECOS | |
| 11:50 AM - 12:00 PM | Closing Remarks | |
